import type { FirestoreConnectorModel } from '../model';
/**
 * Lightweight converter for a root model object. Ensures that the
 * `primaryKey` is not set on the Firestore data.
 */
export declare function coerceModelToFirestore<T extends object>(model: FirestoreConnectorModel<T>, data: T): T;
/**
 * Lightweight converter that converts known custom classes
 * to Firestore-compatible values.
 */
export declare function coerceToFirestore<T extends object>(data: T): T;
