import { FirestoreConnectorModel } from './model';
import type { Transaction } from './db/transaction';
import type { Reference, SetOpts } from './db/reference';
export declare function shouldUpdateRelations(opts: SetOpts | undefined): boolean;
/**
 * Parse relation attributes on this updated model and update the referred-to
 * models accordingly.
 */
export declare function relationsUpdate<T extends object>(model: FirestoreConnectorModel<T>, ref: Reference<T>, prevData: T | undefined, newData: T | undefined, editMode: 'create' | 'update', transaction: Transaction): Promise<void>;
export declare function buildRelations<T extends object>(model: FirestoreConnectorModel<T>, strapiInstance?: import("./types").Strapi): void;
