"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildPrefixQuery = void 0;
/**
 * Firestore-native method to query for prefix.
 * See: https://stackoverflow.com/a/46574143/1513557
 * @param value
 */
function buildPrefixQuery(value) {
    return {
        gte: value,
        lt: value.slice(0, -1) + String.fromCharCode(value.charCodeAt(value.length - 1) + 1), // Lexicographically increment the last character
    };
}
exports.buildPrefixQuery = buildPrefixQuery;
