import type { Firestore } from '@google-cloud/firestore';
import type { ConnectorOptions, ModelOptions } from '../types';
import type { FirestoreConnectorModel } from '../model';
export declare type TransactionRunner<T extends object> = FirestoreConnectorModel<T>['runTransaction'];
/**
 * Makes a function that runs a transaction.
 * If the connector is using an emulator then the return runner queues transactions
 * with a maximum concurrency limit.
 */
export declare function makeTransactionRunner<T extends object>(firestore: Firestore, options: Required<ModelOptions<T>>, connectorOptions: Required<ConnectorOptions>): TransactionRunner<T>;
